function RHS = build_spline_col(n,F,dF_bdry1,dF_bdry2,dF_bdry3,dF_bdry4);
% ordering of the rhs data for splines2a
% for points where more than one value assogned, 
% order them value, value'; in case of 
% corners: value, Dy_value, Dx_value, 
% where Dx and Dy derivatives should be understood in 
% the direction of outer normal
%
% for this, at first EXTEND the original rhs 
% by one more grid point in each direction
% where at the artifically introduced ghost layer put the derivative values
% in the corners put dummies, as they are not used
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

F_ext = zeros(n+2,n+2);
F_ext(2:n+1,2:n+1) = F;
F_ext(2:n+1,1) = dF_bdry1;
F_ext(n+2,2:n+1) = dF_bdry2;
F_ext(2:n+1,n+2) = dF_bdry3;
F_ext(1,2:n+1) = dF_bdry4;

F_ext(1,1) = NaN;
F_ext(1,n+2) = NaN;
F_ext(n+2,n+2) = NaN;
F_ext(n+2,1) = NaN;

RHS = reshape(F_ext,[(n+2)^2,1]);
% cut out the corners
% they have indices
% 1, n+2, (n+2)^2-(n+1), (n+2)^2
RHS([1, n+2, (n+2)^2-(n+1), (n+2)^2]) = [];
       