function [PU,PV] = evaluate_interpolant(x_m,y_m,U,V,x,y,n,h);
% given the spline coefficients U and V for two functions
% compute the interpolant values PU and PV at the positions
% (x_m,y_m)
% for more information: exercise 2, sheet 1
% a double output to save time

nn = length(x_m);

% sum the interpolants
PU = zeros(nn,1);
PV = zeros(nn,1);

% j=-1;
for i=1:n
  PU = PU+U(i)*basis((x_m-x(i))./h).*basis((y_m-(-h))./h);
  PV = PV+V(i)*basis((x_m-x(i))./h).*basis((y_m-(-h))./h);  
end
 
ctr = n;
for j=1:n
  ctr = ctr+1;
  PU = PU+U(ctr)*basis((x_m-(-h))./h).*basis((y_m-y(j))./h);
  PV = PV+V(ctr)*basis((x_m-(-h))./h).*basis((y_m-y(j))./h);
  
  for i=1:n
    ctr = ctr+1;
    PU = PU+U(ctr)*basis((x_m-x(i))./h).*basis((y_m-y(j))./h);
    PV = PV+V(ctr)*basis((x_m-x(i))./h).*basis((y_m-y(j))./h);    
  end
  
  ctr = ctr+1;
  PU = PU+U(ctr)*basis((x_m-(1+h))./h).*basis((y_m-y(j))./h);
  PV = PV+V(ctr)*basis((x_m-(1+h))./h).*basis((y_m-y(j))./h);  
  
end
  
% j=n+1;
for i=1:n
  ctr = ctr+1; 
  PU = PU+U(ctr)*basis((x_m-x(i))./h).*basis((y_m-(1+h))./h);
  PV = PV+V(ctr)*basis((x_m-x(i))./h).*basis((y_m-(1+h))./h);  
end
  
