function A = spline_matrix(x,y,h);



F = rand(n,n);

% derivative values at the boundary points
% boundary consists of 4 parts

% y=0
bdry1_x = x; bdry1_y = zeros(n,1);
% values of normal derivative at the boundary 1
dF_bdry1 = zeros(n,1);


% x=1
bdry2_x = ones(n,1); bdry2_y = y;
dF_bdry2 = zeros(n,1);

% y=1
bdry3_x = x; bdry3_y = ones(n,1);
dF_bdry3 = zeros(n,1);

% x=0
bdry4_x = zeros(n,1); bdry4_y = y;
dF_bdry4 = zeros(n,1);

% contruct the rhs vector

RHS = build_spline_col(n,F,dF_bdry1,dF_bdry2,dF_bdry3,dF_bdry4);


% build the matrix
% initialise the memory
% dimensionality of the problem:
% all inner points once + boundary points once more
dim = n*n + 4*n;
A = sparse(dim,dim);

% template matrix for basis product 
% repeats in all cases
basis_product = [1/6*1/6 1/6*2/3 1/6*1/6; ...
                 2/3*1/6 2/3*2/3 2/3*1/6; ...
		 1/6*1/6 1/6*2/3 1/6*1/6];

% first n columns of A correspond to 
% basis functions 
% j=0 
% psi_{:,0}
for i=1:n
  % compute the operator F psi
  % psi at the grid points
  % column_vector*row_vector to construct basis
  
  psi = sparse(basis((x-x(i))./h)*basis((y'-(-h))./h));
     
    
  % normal derivatives at the boundaries
  dF_psi1 = -1/h*basis((bdry1_x-x(i))./h).*Dbasis((bdry1_y-(-h))./h);
  dF_psi1 = sparse(dF_psi1);
  
  dF_psi2 = 1/h*Dbasis((bdry2_x-x(i))./h).*basis((bdry2_y-(-h))./h);
  dF_psi2 = sparse(dF_psi2);

  dF_psi3 = 1/h*basis((bdry3_x-x(i))./h).*Dbasis((bdry3_y-(-h))./h);
  dF_psi3 = sparse(dF_psi3);
  
  dF_psi4 = -1/h*Dbasis((bdry4_x-x(i))./h).*basis((bdry4_y-(-h))./h);
  dF_psi4 = sparse(dF_psi4);
  
  col = build_spline_col(n,psi,dF_psi1,dF_psi2,dF_psi3,dF_psi4);
           
  A(:,i) = col;
end

% column counter
ctr = n;  

% points with j=1:n
for j=1:n
  % left boundary point treated separately
  
  % compute the operator F psi
  % psi at the grid points
  %psi = sparse(basis((x-(-h))./h)*basis((y'-y(j))./h));  
  psi = sparse(n,n);
  
  if j>1  
    psi(1,j-1) = 1/6*1/6;
  end
    
  psi(1,j) = 2/3*1/6;
  
  if j<n
    psi(1,j+1) = 1/6*1/6;
  end
      
  
  
  % normal derivatives at the boundaries
  dF_psi1 = -1/h*basis((bdry1_x-(-h))./h).*Dbasis((bdry1_y-y(j))./h);
  dF_psi1 = sparse(dF_psi1);
  
  dF_psi2 = 1/h*Dbasis((bdry2_x-(-h))./h).*basis((bdry2_y-y(j))./h);
  dF_psi2 = sparse(dF_psi2);

  dF_psi3 = 1/h*basis((bdry3_x-(-h))./h).*Dbasis((bdry3_y-y(j))./h);
  dF_psi3 = sparse(dF_psi3);
  
  dF_psi4 = -1/h*Dbasis((bdry4_x-(-h))./h).*basis((bdry4_y-y(j))./h);
  dF_psi4 = sparse(dF_psi4);

  col = build_spline_col(n,psi,dF_psi1,dF_psi2,dF_psi3,dF_psi4);
         
  ctr = ctr+1;  
  A(:,ctr) = col;
 
  
  % the inner basis functions
  for i=1:n
    % compute the operator F psi
    % psi at the grid points
    % psi = sparse(basis((x-x(i))./h)*basis((y'-y(j))./h));

    % replace by
    psi_dummy = sparse(n+2,n+2);
    % in psi_dummy indices are shifted by one 
    % but we do not need to take care of special cases near 
    % corners and edges     
  
    psi_dummy([i:i+2],[j:j+2]) = basis_product;
    psi = psi_dummy(2:n+1,2:n+1);
        
      
    % normal derivatives at the boundaries
    dF_psi1 = -1/h*basis((bdry1_x-x(i))./h).*Dbasis((bdry1_y-y(j))./h);
    dF_psi1 = sparse(dF_psi1);
  
    dF_psi2 = 1/h*Dbasis((bdry2_x-x(i))./h).*basis((bdry2_y-y(j))./h);
    dF_psi2 = sparse(dF_psi2);

    dF_psi3 = 1/h*basis((bdry3_x-x(i))./h).*Dbasis((bdry3_y-y(j))./h);
    dF_psi3 = sparse(dF_psi3);
  
    dF_psi4 = -1/h*Dbasis((bdry4_x-x(i))./h).*basis((bdry4_y-y(j))./h);
    dF_psi4 = sparse(dF_psi4);

    col = build_spline_col(n,psi,dF_psi1,dF_psi2,dF_psi3,dF_psi4);
       
    ctr = ctr+1;  
    A(:,ctr) = col;    
            
  end
  
  % right boundary treated separately
  % compute the operator F psi
  % psi at the grid points
  %psi = sparse(basis((x-(1+h))./h)*basis((y'-y(j))./h));
  
  
  psi = sparse(n,n);
  
  if j>1  
    psi(n,j-1) = 1/6*1/6;
  end
    
  psi(n,j) = 2/3*1/6;
  
  if j<n
    psi(n,j+1) = 1/6*1/6;
  end
  
  
  % normal derivatives at the boundaries
  dF_psi1 = -1/h*basis((bdry1_x-(1+h))./h).*Dbasis((bdry1_y-y(j))./h);
  dF_psi1 = sparse(dF_psi1);
  
  dF_psi2 = 1/h*Dbasis((bdry2_x-(1+h))./h).*basis((bdry2_y-y(j))./h);
  dF_psi2 = sparse(dF_psi2);

  dF_psi3 = 1/h*basis((bdry3_x-(1+h))./h).*Dbasis((bdry3_y-y(j))./h);
  dF_psi3 = sparse(dF_psi3);
  
  dF_psi4 = -1/h*Dbasis((bdry4_x-(1+h))./h).*basis((bdry4_y-y(j))./h);
  dF_psi4 = sparse(dF_psi4);
  
  col = build_spline_col(n,psi,dF_psi1,dF_psi2,dF_psi3,dF_psi4);
         
  ctr = ctr+1;  
  A(:,ctr) = col;  
                
end

% last n columns of A correspond to 
% basis functions 
% j=n+1
% psi_{:,n+1}
for i=1:n
  % compute the operator F psi
  % psi at the grid points
  psi = sparse(basis((x-x(i))./h)*basis((y'-(1+h))./h));
  
  
  % normal derivatives at the boundaries
  dF_psi1 = -1/h*basis((bdry1_x-x(i))./h).*Dbasis((bdry1_y-(1+h))./h);
  dF_psi1 = sparse(dF_psi1);
  
  dF_psi2 = 1/h*Dbasis((bdry2_x-x(i))./h).*basis((bdry2_y-(1+h))./h);
  dF_psi2 = sparse(dF_psi2);

  dF_psi3 = 1/h*basis((bdry3_x-x(i))./h).*Dbasis((bdry3_y-(1+h))./h);
  dF_psi3 = sparse(dF_psi3);
  
  dF_psi4 = -1/h*Dbasis((bdry4_x-x(i))./h).*basis((bdry4_y-(1+h))./h);
  dF_psi4 = sparse(dF_psi4);

  col = build_spline_col(n,psi,dF_psi1,dF_psi2,dF_psi3,dF_psi4);
           
  ctr = ctr+1;  
  A(:,ctr) = col;  
  
end

U = A\RHS;

% visualise the interpolated function
% on much finer mesh
xx = linspace(0,1,10*n)';
yy = linspace(0,1,10*n)';



% sum the interpolants
P = zeros(10*n,10*n);

% j=-1;
for i=1:n
  P = P+U(i)*basis((xx-x(i))./h)*basis((yy'-(-h))./h);
end
 
ctr = n;
for j=1:n
  ctr = ctr+1;
  P = P+U(ctr)*basis((xx-(-h))./h)*basis((yy'-y(j))./h);
  
  for i=1:n
    ctr = ctr+1;
    P = P+U(ctr)*basis((xx-x(i))./h)*basis((yy'-y(j))./h);
  end
  
  ctr = ctr+1;
  P = P+U(ctr)*basis((xx-(1+h))./h)*basis((yy'-y(j))./h);

end

% j=n+1;
for i=1:n
  ctr = ctr+1; 
  P = P+U(ctr)*basis((xx-x(i))./h)*basis((yy'-(1+h))./h);
end


figure(1)
[XX,YY] = ndgrid(xx,yy);
surf(XX,YY,P);
hold on

% generate arrays X and Y for visualisation
[X,Y] = ndgrid(x,y);

N = n*n;
plot3(reshape(X,N,1),reshape(Y,N,1),reshape(F,N,1),'r*');  

xlabel('x');
ylabel('y');

shading flat